import type { HttpEndpoint } from '@cosmjs/tendermint-rpc';
import { Coin, Secp256k1HdWallet, SigningCosmWasmClient } from 'cosmwasm';
declare type Config = {
    global: {
        account_prefix: string;
        derivation_path: string;
        networks: {
            [x: string]: {
                rpc_endpoint: string | HttpEndpoint;
            };
        };
        gas_price: string;
        accounts: Record<string, {
            mnemonic: string;
        }>;
    };
};
/**
 * Account instance with baked-in client and utility methods
 */
export declare class Account {
    signingClient: SigningCosmWasmClient;
    wallet: Secp256k1HdWallet;
    address: string;
    constructor(wallet: Secp256k1HdWallet, signingClient: SigningCosmWasmClient, address: string);
    static withDerivedAddress(wallet: Secp256k1HdWallet, signingClient: SigningCosmWasmClient): Promise<Account>;
    /**
     * Get balances for specific denom, only support native coin
     */
    getBalance(denom: string): Promise<Coin>;
}
export declare const fromMnemonic: (conf: Config, network: string | number, mnemonic: string) => Promise<Account>;
export declare const getAccounts: (conf: Config, network: string) => Promise<{
    [k: string]: Account | undefined;
}>;
export {};
//# sourceMappingURL=account.d.ts.map